private import win32.windows;
// todo: popup menu




struct MENU {
    uint    option;
    uint    id;
    wchar[] text;
};




class CMenu {
public:
    HMENU   hMenu;




public:
    // create window menu
    this()
    {
    }


    // create popup menu
    this(MENU[] menu_list)
    {
        create(menu_list);
    }


    // destroy
    ~this()
    {
        destroy();
    }




public:
    // create popup menu
    void create(MENU[] menu_list)
    {
        hMenu = CreatePopupMenu();
        if (hMenu == null) throw new Exception("createMenu(); failed to create menu");
        foreach (i, mn; menu_list) {
            InsertMenuW(hMenu, i, MF_BYPOSITION | MF_STRING | mn.option, mn.id, mn.text.ptr);
        }
    }


    // destroy menu
    void destroy()
    {
        DestroyMenu(hMenu);
    }


    // popup menu at mouse position
    void popup(HWND hWnd)
    {
        POINT pt;
        GetCursorPos(&pt);
        TrackPopupMenu(hMenu, TPM_LEFTALIGN | TPM_LEFTBUTTON, pt.x, pt.y, 0, hWnd, null);
    }
    
    
    // check
    void check(uint idCheck, bool chk=true)
    {
        CheckMenuItem(hMenu, idCheck, MF_BYCOMMAND | ((chk)?MF_CHECKED:MF_UNCHECKED));
    }
    
    
    // uncheck all and check one
    void check(uint idCheck, uint idFirst, uint idLast)
    {
        int iFirst = getPosition(idFirst);
        int iLast  = getPosition(idLast);
       
        for (int i=iFirst; i<=iLast; i++) { CheckMenuItem(hMenu, i, MF_BYPOSITION | MF_UNCHECKED); }
        CheckMenuItem(hMenu, idCheck, MF_BYCOMMAND | MF_CHECKED);
    }
    
    
    // get position from id
    int getPosition(uint id)
    {
        int imax = getCount();
        if (imax == -1) return -1;
        for (int i=0; i<imax; i++) {
            if (id == GetMenuItemID(hMenu, i)) return i;
        }
        return -1;
    }
    
    
    // get count
    int getCount()
    {
        return GetMenuItemCount(hMenu);
    }
}

