import std.string;
import win32.windows;




void setLogFont(LOGFONT* pLogFont, char[] strFontName, int iHeight)
{
    pLogFont.lfHeight         = iHeight;
    pLogFont.lfWidth          = 0;
    pLogFont.lfEscapement     = 0;
    pLogFont.lfOrientation    = 0;
    pLogFont.lfWeight         = FW_NORMAL;
    pLogFont.lfItalic         = FALSE;
    pLogFont.lfUnderline      = FALSE;
    pLogFont.lfStrikeOut      = FALSE;
    pLogFont.lfCharSet        = DEFAULT_CHARSET;
    pLogFont.lfOutPrecision   = OUT_DEFAULT_PRECIS;
    pLogFont.lfClipPrecision  = OUT_DEFAULT_PRECIS;
    pLogFont.lfQuality        = DEFAULT_QUALITY;
    pLogFont.lfPitchAndFamily = FF_DONTCARE | FIXED_PITCH;
    pLogFont.lfFaceName[0..64] = toStringz(strFontName)[0..64];
}




void copyLogFont(LOGFONT* pLogFontDst, LOGFONT* pLogFontSrc)
{
    pLogFontDst.lfHeight         = pLogFontSrc.lfHeight;
    pLogFontDst.lfWidth          = pLogFontSrc.lfWidth;
    pLogFontDst.lfEscapement     = pLogFontSrc.lfEscapement;
    pLogFontDst.lfOrientation    = pLogFontSrc.lfOrientation;
    pLogFontDst.lfWeight         = pLogFontSrc.lfWeight;
    pLogFontDst.lfItalic         = pLogFontSrc.lfItalic;
    pLogFontDst.lfUnderline      = pLogFontSrc.lfUnderline;
    pLogFontDst.lfStrikeOut      = pLogFontSrc.lfStrikeOut;
    pLogFontDst.lfCharSet        = pLogFontSrc.lfCharSet;
    pLogFontDst.lfOutPrecision   = pLogFontSrc.lfOutPrecision;
    pLogFontDst.lfClipPrecision  = pLogFontSrc.lfClipPrecision;
    pLogFontDst.lfQuality        = pLogFontSrc.lfQuality;
    pLogFontDst.lfPitchAndFamily = pLogFontSrc.lfPitchAndFamily;
    pLogFontDst.lfFaceName[0..64] = pLogFontSrc.lfFaceName[0..64];
}




int setBMI(BITMAPINFOHEADER* pBMI, BITMAPFILEHEADER* pBFH, int iWidth, int iHeight, int iBitCount)
{
    int iWidth32 = (((iWidth * iBitCount) >> 3) + 3) & ~0x03;

    pBMI.biSize = BITMAPINFOHEADER.sizeof;
    pBMI.biWidth = iWidth;
    pBMI.biHeight = iHeight;
    pBMI.biSizeImage = iWidth32 * iHeight;
    pBMI.biPlanes = 1;
    pBMI.biBitCount = iBitCount;
    pBMI.biCompression = 0;
    pBMI.biClrUsed = 0;
    pBMI.biClrImportant = 0;
    pBMI.biXPelsPerMeter = 0;
    pBMI.biYPelsPerMeter = 0;

    if (pBFH != null) {
        pBFH.bfType = 0x4d42;
        pBFH.bfReserved1 = 0;
        pBFH.bfReserved2 = 0;
        pBFH.bfOffBits = BITMAPFILEHEADER.sizeof + BITMAPINFOHEADER.sizeof;
        pBFH.bfSize =  pBFH.bfOffBits + pBMI.biSizeImage;
    }

    return iWidth32;
}




void setNotifyIconData(NOTIFYICONDATA* pstNtfyIcon, HWND hWnd, UINT uID, HICON hIcon, UINT uMessageID, char[] strTip)
{
    pstNtfyIcon.cbSize = NOTIFYICONDATA.sizeof;
    pstNtfyIcon.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
    pstNtfyIcon.uID = uID;
    pstNtfyIcon.hWnd = hWnd;
    pstNtfyIcon.hIcon = hIcon;
    pstNtfyIcon.uCallbackMessage = uMessageID;
    pstNtfyIcon.szTip[0..64] = toStringz(strTip)[0..64];
}


